class FactorialTest {
    static int fact_iter(int n) {
        int acc = 1;
        for (int i = 2; i < n + 1; i++) {
            acc *= i;
        }
        return acc;
    }

    static int fact_rec(int n) {
        if (n < 2) {
            return 1;
        }
        return fact_rec(n - 1) * n;
    }

    public static void main(String[] args){
        long startTime = System.nanoTime();
        for (int i = 0; i < 20000; i++) {
            fact_iter(i);
        }
        long endTime = System.nanoTime();
        System.out.println("iterative factorial time: " + (endTime - startTime) / 1000000 + "ms");

        startTime = System.nanoTime();
        for (int i = 0; i < 20000; i++) {
            fact_rec(i);
        }
        endTime = System.nanoTime();
        System.out.println("recursive factorial time: " + (endTime - startTime) / 1000000 + "ms");
    }
}